clear all;

%figure()
color = 'r';
linestyle = '-';
marker = 'none'; %none


folder  = strcat('D:\gawoon_workingFolder\BAPTA_50um');%
%piv_files = {'upper1.mat', 'upper2.mat', 'middle.mat', 'lower2.mat', 'lower1.mat'}; 
piv_files = {'1.mat', '2.mat', '3.mat', '4.mat', '5.mat', '6.mat', '7.mat', '8.mat', '9.mat', '10.mat', '11.mat', '12.mat', '13.mat', '14.mat', '15.mat'}; 
%piv_files = {'upper1.mat', 'middle.mat', 'lower2.mat', 'lower1.mat'}; 
fieldStartsAt = 5; % enter slide number



time = 6;

for num = 1:1:length(piv_files)


    test    = piv_files{num};
    info    = fullfile(folder, test);    
    load(info);
    
    
    [x_length, y_length] = size(u_filtered{1, 1}); 
    u = zeros(x_length, y_length, time);
    v = zeros(x_length, y_length, time);
    
    for i = time
        
        u_cur = (u_filtered{i, 1} .* typevector_filtered{i, 1});
        %u_cur = u_cur - mean2(u_cur);
        v_cur = (v_filtered{i, 1} .* typevector_filtered{i, 1}); 
        %v_cur = v_cur - mean2(v_cur);

        speed_cur = sqrt(u_cur.^2 + v_cur.^2);
        
        v_r_total = 0;
        distance = 1; 
        for i_index = 2:1:x_length - 1 
            for j_index = 2:1:y_length - 1
                if any(u_cur(i_index, j_index))
                    cur_vec = [u_cur(i_index, j_index), v_cur(i_index, j_index)];
                    vec1 = [u_cur(i_index , j_index - distance), v_cur(i_index - distance, j_index - distance)];
                    vec2 = [u_cur(i_index , j_index + distance), v_cur(i_index - distance, j_index - distance)];
                    vec3 = [u_cur(i_index - distance, j_index - distance), v_cur(i_index - distance, j_index - distance)];
                    vec4 = [u_cur(i_index - distance, j_index ), v_cur(i_index - distance, j_index - distance)];
                    vec5 = [u_cur(i_index - distance, j_index + distance), v_cur(i_index - distance, j_index - distance)];
                    vec6 = [u_cur(i_index + distance, j_index - distance), v_cur(i_index - distance, j_index - distance)];
                    vec7 = [u_cur(i_index + distance, j_index ), v_cur(i_index - distance, j_index - distance)];
                    vec8 = [u_cur(i_index + distance, j_index + distance), v_cur(i_index - distance, j_index - distance)];
                    vectors = [vec1; vec2; vec3; vec4; vec5; vec6; vec7; vec8];

                    for vecnum = 1:1:8                 
                        new_vec = vectors(vecnum, :);
                        if any(new_vec)
                            v_r(vecnum) = (dot(cur_vec, new_vec)/ (norm(cur_vec)*norm(new_vec)));
                        end
                    end
                    v_R(i_index, j_index) = mean(nonzeros(v_r));
                end
            end
        end
    end  
    v_R_total(num, 1) = mean2(nonzeros(v_R));
end


%%
figure()
%chart = [0 0.25 0.666 0.875 1]
chart = [0 0.25 0.5 0.75 1];
range = [-1 1];
% 10 for 80, 15 for 120
map = customcolormap(chart, {'#900000','#ff0000','#ffffff','#0000ff', '#000080'})%https://www.rapidtables.com/web/color/RGB_Color.html
heatmap(col_x, 'Colormap', map, 'ColorLimits', range, 'GridVisible','off')

%%

    time = 1;
    
    [x_length, y_length] = size(u_filtered{1, 1}); 
    u = zeros(x_length, y_length, time);
    v = zeros(x_length, y_length, time);
    
    for i = time
        u_cur = (u_filtered{i, 1} .* typevector_filtered{i, 1});
        v_cur = (v_filtered{i, 1} .* typevector_filtered{i, 1}); 
        speed_cur = sqrt(u_cur.^2 + v_cur.^2);
        
        col_x = u_cur./ speed_cur;
        col_y = v_cur./ speed_cur;

    end  

    final_col_x = [final_col_x; col_x];
    final_col_y = [final_col_y; col_y];
 

col = mean(sqrt(final_col_x.^2 + final_col_y.^2));
col = nonzeros(col);
mean_col = mean2(col);
std_col = std2(col);
